function varargout = eigenGUI(varargin)
% EIGENGUI MATLAB code for eigenGUI.fig
%      EIGENGUI, by itself, creates a new EIGENGUI or raises the existing
%      singleton*.
%
%      H = EIGENGUI returns the handle to a new EIGENGUI or the handle to
%      the existing singleton*.
%
%      EIGENGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EIGENGUI.M with the given input arguments.
%
%      EIGENGUI('Property','Value',...) creates a new EIGENGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before eigenGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to eigenGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help eigenGUI

% Last Modified by GUIDE v2.5 06-Feb-2017 05:30:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenGUI is made visible.
function eigenGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenGUI (see VARARGIN)

% Choose default command line output for eigenGUI
handles.output = hObject;

% load average face and top 4 eigenfaces, and store in handles structure
load('data.mat')
handles.avg = avgFace(1:2:end, 1:2:end);    % downsample to reduce size
handles.eigen1 = eigen1(1:2:end, 1:2:end);
handles.eigen2 = eigen2(1:2:end, 1:2:end);
handles.eigen3 = eigen3(1:2:end, 1:2:end);
handles.eigen4 = eigen4(1:2:end, 1:2:end);
% make initial images with positive/negative eigenface images & axes
[handles.init12, handles.init34] = getInitIms(handles.avg, handles.eigen1, ...
                               handles.eigen2, handles.eigen3, handles.eigen4);
handles.current = handles.init12;   % initial background for eigenfaces 1 & 2
imshow(handles.current)
handles.cumFace = handles.avg;      % initialize cumulative image
handles.weightX = 0;                % initialize weight values
handles.weightY = 0;
handles.adds = {};                  % stores face images to "keep"
handles.xc = [];                    % x,y coordinates of "kept" images
handles.yc = [];
% load arrays of 80 face images and first 25 eigenfaces
handles.faces = imread('faceDB.png');
handles.eigenfaces = imread('facesEigen.png');
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = eigenGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on slider movement.
function Yslider_Callback(hObject, eventdata, handles)
% hObject    handle to Yslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% adjusts display following changes in Y slider
yval = get(handles.Yslider, 'Value');   % update Y weight and label
handles.weightY = (yval*80)-40;
set(handles.YweightLabel, 'String', ['weight = ' num2str(handles.weightY)]);
im = handles.current;       % initialize new image display
% generate new composite image from average face and eigenfaces
if (get(handles.eigenButton1, 'Value') == 1)
    handles.cumFace = handles.avg + (handles.weightX * handles.eigen1) + ...
                                    (handles.weightY * handles.eigen2);
else
    handles.cumFace = handles.avg + (handles.weightX * handles.eigen3) + ...
                                    (handles.weightY * handles.eigen4);
end
handles.cumFace = norm01(handles.cumFace);  % normalize range to 0 to 1
% place new cumulative face at the end of the handles.adds cell array and
% also store away the x,y location for this face image
if (isempty(handles.adds))
    handles.adds{1} = handles.cumFace;
    handles.xc(1) = 195 + ((handles.weightX + 40)/80)*418;
    handles.yc(1) = 213 + ((handles.weightY + 40)/80)*382;
else
    handles.adds{end} = handles.cumFace;
    handles.xc(end) = 195 + ((handles.weightX + 40)/80)*418;
    handles.yc(end) = 213 + ((handles.weightY + 40)/80)*382;
end
% add images from the handle.adds cell array to the display image
for i = 1:length(handles.adds)
    xc = round(handles.xc(i)-55);
    yc = round(handles.yc(i)-64);
    yc = 808 - yc - 128;
    im(yc:(yc+127), xc:(xc+108)) = handles.adds{i};
end
im = norm01(im);        % normalize intensity to the range from 0 to 1
imshow(im)              % show new display image
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Yslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Yslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function Xslider_Callback(hObject, eventdata, handles)
% hObject    handle to Xslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% adjusts display following changes in Y slider
xval = get(handles.Xslider, 'Value');   % update Y weight and label
handles.weightX = (xval*80)-40;
set(handles.XweightLabel, 'String', ['weight = ' num2str(handles.weightX)]);
im = handles.current;                   % initialize new image display
% generate new composite image from average face and eigenfaces
if (get(handles.eigenButton1, 'Value') == 1)
    handles.cumFace = handles.avg + (handles.weightX * handles.eigen1) + ...
                                    (handles.weightY * handles.eigen2);
else
    handles.cumFace = handles.avg + (handles.weightX * handles.eigen3) + ...
                                    (handles.weightY * handles.eigen4);
end
handles.cumFace = norm01(handles.cumFace);  % normalize range to 0 to 1
% place new cumulative face at the end of the handles.adds cell array and
% also store away the x,y location for this face image
if (isempty(handles.adds))
    handles.adds{1} = handles.cumFace;
    handles.xc(1) = 195 + ((handles.weightX + 40)/80)*418;
    handles.yc(1) = 213 + ((handles.weightY + 40)/80)*382;
else
    handles.adds{end} = handles.cumFace;
    handles.xc(end) = 195 + ((handles.weightX + 40)/80)*418;
    handles.yc(end) = 213 + ((handles.weightY + 40)/80)*382;
end
% add images from the handle.adds cell array to the display image
for i = 1:length(handles.adds)
    xc = round(handles.xc(i)-55);
    yc = round(handles.yc(i)-64);
    yc = 808 - yc - 128;
    im(yc:(yc+127), xc:(xc+108)) = handles.adds{i};
end
im = norm01(im);        % normalize intensity to the range from 0 to 1
imshow(im)              % show new display image
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Xslider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Xslider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on button press in closeButton.
function closeButton_Callback(hObject, eventdata, handles)
% hObject    handle to closeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(handles.figure1)

% --- Executes on button press in refreshButton.
function refreshButton_Callback(hObject, eventdata, handles)
% hObject    handle to refreshButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% reset state of GUI back to initial state, taking into account the
% current selection of eigenfaces pair
if (get(handles.eigenButton1, 'Value') == 1)
    handles.current = handles.init12;
else
    handles.current = handles.init34;
end
imshow(handles.current)
% reset state of the weight sliders and labels, and reset weights
set(handles.Xslider, 'Value', 0.5);
set(handles.XweightLabel, 'String', 'weight = 0')
handles.weightX = 0;
set(handles.Yslider, 'Value', 0.5);
set(handles.YweightLabel, 'String', 'weight = 0')
handles.weightY = 0;
% reset cell array of added images
handles.adds = {};
handles.xc = [];
handles.yc = [];

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in keepButton.
function keepButton_Callback(hObject, eventdata, handles)
% hObject    handle to keepButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% adds current image to handles.adds cell array, to keep on display
handles.adds{end+1} = handles.adds{end};
handles.xc(end+1) = handles.xc(end);
handles.yc(end+1) = handles.yc(end);
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in removeButton.
function removeButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in viewButton.
function viewButton_Callback(hObject, eventdata, handles)
% hObject    handle to viewButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure('Position', [100 100 800 700])
imshow(handles.faces)

% --- Executes on button press in eigenViewButton.
function eigenViewButton_Callback(hObject, eventdata, handles)
% hObject    handle to eigenViewButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure('Position', [100 100 500 700])
imshow(handles.eigenfaces)
