function [init12, init34] = getInitIms(avgFace, eigen1, eigen2, eigen3, eigen4)
% creates initial large image with two eigenfaces axes, showing positive
% and negative eigenfaces 1 and 2 (for init12) or 3 and 4 (for init34),
% and average face in the center

init12 = ones(808, 808);        % initial white backgrounds
init34 = ones(808, 808);

eigen1 = norm01(eigen1);        % normalize range of intensity in
eigen2 = norm01(eigen2);        % eigenface images to be from 0 to 1
eigen3 = norm01(eigen3);
eigen4 = norm01(eigen4);

init12(403:405, 140:668) = 0;   % draw axis lines
init12(149:659, 403:405) = 0;
init12(341:468, 350:458) = avgFace;     % add average face at center
init12(341:468, 11:119) = (1 - eigen1); % positive/negative eigenface #1
init12(341:468, 689:797) = eigen1;
init12(11:138, 350:458) = eigen2;       % positive/negative eigenface #2
init12(670:797, 350:458) = (1 - eigen2);

init34(403:405, 140:668) = 0;   % draw axis lines
init34(149:659, 403:405) = 0;
init34(341:468, 350:458) = avgFace;     % add average face at center
init34(341:468, 11:119) = (1 - eigen3); % positive/negative eigenface #3
init34(341:468, 689:797) = eigen3;
init34(11:138, 350:458) = eigen4;       % positive/negative eigenface #4
init34(670:797, 350:458) = (1 - eigen4);

end

